#=======================================================================
# Orinal author : Jos Cludio Faria
# Objective     : To supply the current necessity of the Tinn-R project
# Date          : 2023-02-20 00:38:18
#=======================================================================

TR_Apropos <- function(object,
                       sep='|',
                       path=NULL)
{
  res <- apropos(object,
                 where=TRUE)

  nam_res <- names(res)
  obj_res <- as.character(res)
  lpack <- search()
  obj_packs <- lpack[as.integer(nam_res)]

  res <- paste(obj_res,
               obj_packs,
               sep=sep)

  if(is.null(path))
    return(res)
  else
    write.table(res,
                file=path,
                row.names=FALSE,
                quote=FALSE,
                sep=sep)
}
