#. BUG: corrections
#.. TR_Code_Completion
# TR_Code_Completion <- function(obj,
#                                slots=c('name',
#                                        'title',
#                                        'description'),
#                                sep='|',
#                                path=NULL)

#-----------------------------
#... values to manual debug
#-----------------------------
obj <- '^sd'
slots <- c('name',
           'title',
           'description')
sep <- '|'
path=NULL
#-----------------------------

#. TR_Get_Help
# TR_Get_Help <- function(obj=NULL,
#                         pkg=NULL,
#                         slots=c('name',
#                                 'title',
#                                 'description'))

#-----------------------------
#... values to manual debug
#-----------------------------
obj <- 'scan'
pkg <- 'base'
slots <- c('name',
           'title',
           'description')

slots <- c('arguments')

#. Tuning

#.. options('width'=30)
options(width=30)
TR_Code_Completion('^av')

[1] "available.packages|utils|available.packages|List Available Packages at CRAN-like Repositories|\n  available.packages returns a matrix of details corresponding to\n  packages currently available at one or more repositories. The\n  current list of packages is downloaded over the internet (or copied\n  from a local mirror).\n|\navailable.packages(contriburl = contrib.url(repos, type), method,\n                   fields = NULL, type = getOption(\"pkgType\"),\n                   filters = NULL, repos = getOption(\"repos\"),\n                   ignore_repo_cache = FALSE, max_repo_cache_age,\n                   quiet = TRUE, )\n"
[2] "ave|stats|ave|Group Averages Over Level Combinations of Factors|\n  Subsets of x[] are averaged, where each subset consist of those\n  observations with the same factor levels.\n|\nave(x, , FUN = mean)\n"

#.. options('width'=300)
options(width=300)
TR_Code_Completion('^av')

[1] "available.packages|utils|available.packages|List Available Packages at CRAN-like Repositories|\n  available.packages returns a matrix of details corresponding to\n  packages currently available at one or more repositories. The\n  current list of packages is downloaded over the internet (or copied\n  from a local mirror).\n|\navailable.packages(contriburl = contrib.url(repos, type), method,\n                   fields = NULL, type = getOption(\"pkgType\"),\n                   filters = NULL, repos = getOption(\"repos\"),\n                   ignore_repo_cache = FALSE, max_repo_cache_age,\n                   quiet = TRUE, )\n"
[2] "ave|stats|ave|Group Averages Over Level Combinations of Factors|\n  Subsets of x[] are averaged, where each subset consist of those\n  observations with the same factor levels.\n|\nave(x, , FUN = mean)\n"


#. Functions: tests
library(fdth)
library(MASS)
library(cluster)
library(xtable)

#.. All results
#... Low case
TR_Code_Completion('^a')  # 266 - OK
TR_Code_Completion('^b')  #  69 - OK
TR_Code_Completion('^c')  # 190 - OK
TR_Code_Completion('^d')  # 155 - OK
TR_Code_Completion('^e')  #  65 - OK
TR_Code_Completion('^f')  # 115 - OK
TR_Code_Completion('^g')  # 125 - OK
TR_Code_Completion('^h')  #  34 - OK
TR_Code_Completion('^i')  # 142 - OK
TR_Code_Completion('^j')  #   5 - OK
TR_Code_Completion('^k')  #  13 - OK
TR_Code_Completion('^l')  # 106 - OK
TR_Code_Completion('^m')  # 135 - OK
TR_Code_Completion('^n')  #  66 - OK
TR_Code_Completion('^o')  #  26 - OK
TR_Code_Completion('^p')  # 274 - OK
TR_Code_Completion('^q')  #  52 - OK
TR_Code_Completion('^r')  # 161 - OK
TR_Code_Completion('^s')  # 309 - OK
TR_Code_Completion('^t')  #  87 - OK
TR_Code_Completion('^u')  #  47 - OK
TR_Code_Completion('^v')  #  21 - OK
TR_Code_Completion('^w')  #  61 - OK
TR_Code_Completion('^x')  #  36 - OK
TR_Code_Completion('^y')  #   1 - OK
TR_Code_Completion('^z')  #   3 - OK

#... Upper case
TR_Code_Completion('^A')  #  9 - OK
TR_Code_Completion('^B')  #  6 - OK
TR_Code_Completion('^C')  # 10 - OK
TR_Code_Completion('^D')  #  5 - OK
TR_Code_Completion('^E')  #  3 - OK
TR_Code_Completion('^F')  #  5 - OK
TR_Code_Completion('^G')  #  2 - OK
TR_Code_Completion('^H')  #  5 - OK
TR_Code_Completion('^I')  #  8 - OK
TR_Code_Completion('^J')  #  1 - OK
TR_Code_Completion('^K')  #  4 - OK
TR_Code_Completion('^L')  #  8 - OK
TR_Code_Completion('^M')  # 13 - OK
TR_Code_Completion('^N')  # 10 - OK
TR_Code_Completion('^O')  # 12 - OK
TR_Code_Completion('^P')  #  8 - OK
TR_Code_Completion('^Q')  #  1 - OK
TR_Code_Completion('^R')  # 29 - OK
TR_Code_Completion('^S')  # 58 - OK
TR_Code_Completion('^T')  # 15 - OK
TR_Code_Completion('^U')  # 13 - OK
TR_Code_Completion('^V')  #  4 - OK
TR_Code_Completion('^W')  #  2 - OK
TR_Code_Completion('^X')  #  1 - OK
TR_Code_Completion('^Y')  #  0 - OK [No objects found starting with: ^Y]
TR_Code_Completion('^Z')  #  0 - OK [No objects found starting with: ^Y]

#.. Results
TR_Code_Completion('^sa')  # 12 - OK
TR_Code_Completion('^se')  # 70 - OK
TR_Code_Completion('^si')  # 20 - OK
TR_Code_Completion('^so')  # 17 - OK
TR_Code_Completion('^su')  # 50 - OK


#.. Big results
TR_Code_Completion('^a')  # 266 - OK
TR_Code_Completion('^p')  # 274 - OK
TR_Code_Completion('^s')  # 309 - OK

#.. To file
TR_Code_Completion('^sa',
                   path='.paths[11]')  # 12 - OK

TR_Code_Completion('^se',
                   path='.paths[11]')  # 70 - OK

TR_Code_Completion('^si',
                   path='.paths[11]')  # 20 - OK

TR_Code_Completion('^so',
                   path='.paths[11]')  # 17 - OK

TR_Code_Completion('^su',
                   path='.paths[11]')  # 50 - OK

#. How to send the information to Tinn?
#.. object|package|name|title|description|usage
"validEnc"|"base"|"validUTF8"|"Check if a Character Vector is Validly Encoded"|"\n  Check if each element of a character vector is valid in its implied\n  encoding.\n"|"\nvalidUTF8(x)\nvalidEnc(x)\n"
"validObject"|"methods"|"validObject"|" Test the Validity of an Object "|"\n  validObject() tests the validity of object related to\n  its class definition; specifically, it checks that"|"\nvalidObject(object, test = FALSE, complete = FALSE)\n\nsetValidity(Class, method, where = topenv(parent.frame"

#.. BUGS TO SEE
TR_Code_Completion('^va')  # 9 OK
va|                        # 9 OK

TR_Code_Completion('^ve')  # 2 OK
ve|                        # 2 OK

TR_Code_Completion('^vi')  # 2 OK
vi|                        # ???

TR_Code_Completion('^vo')  # 3 OK
vo|                        # ???

TR_Code_Completion('^vu')  # No objects found starting with: ^vu
vu|                        # ??? -> est mostrando a janela de DLG e no deve!

TR_Code_Completion('^sd')  # 5 OK
sd|                        # ???

TR_Code_Completion('^var') # 8 OK
var|                       # ???
