#=======================================================================
# Orinal author : Philippe Grosjean
# Original code : [svMisc] objSearch function
# Adapted by    : Jos Cludio Faria
# Objective     : To supply the current necessity of the Tinn-R project
# Date          : 2023-02-20 00:44:47
#=======================================================================

TR_Obj_Search <- function(sep='\t',
                          path=NULL)
{
  res <- data.frame(search())
  if(is.null(path))
    return(res)
  else
    write.table(res,
                file=path,
                row.names=FALSE,
                quote=FALSE,
                sep=sep)
}
