\name{TR_Args_Description}
\alias{TR_Args_Description}

\title{
  Get detailed information about function arguments
}

\description{
  Get detailed information about all function arguments in help files.
}

\usage{
  TR_Args_Description(object,
                      package=NULL,
                      section='Arguments',
                      sep='|',
                      path=NULL)
}

\arguments{
  \item{object}{An R object.}
  \item{sep}{Separator to use between items in the file (if file is not \code{NULL}).}
  \item{package}{a name or character vector giving the packages to look into for documentation, or NULL. By default, all packages whose namespaces are loaded are used. To avoid a name being deparsed use e.g. (pkg_ref) (see the examples).}
  \item{section}{Which section from the full documentation list should be returned.}
  \item{path}{The path. \code{NULL} is the default.}
}

\value{
  All arguments of a function from help files.
}

\keyword{utilities}
