\name{TR_Code_Completion}
\alias{TR_Code_Completion}

\title{
  Get a informative vector of R searched by \code{utils:::apropos} and \code{TR_Obj_Describe} functions
}

\description{
  Describe R objects from loaded packages with documentation details.
}

\usage{
  TR_Code_Completion(object,
                     slots=c('name',
                             'title',
                             'description'),
                     sep='|',
                     path=NULL)
}

\arguments{
  \item{object}{An R object.}
  \item{sep}{Separator to use between items in the file (if file is not \code{NULL}).}
  \item{slots}{Which slots from the full documentation list should be returned. The default are the slots: 'name', 'title' and 'description'.}
  \item{path}{The path. \code{NULL} is the default.}
}

\value{
  A descriptive list of an R object.
}

\keyword{utilities}
