\name{TR_Export}
\alias{TR_Export}

\title{
  Export the content of an object in a foreign format
}

\description{
  \code{TR_Export} is a generic function (S3 based) to convert objects into
  foreign formats and write it to a file or a connection.
}

\usage{
  TR_Export(x,
            type="raw",
            file="clipboard")
}

\arguments{
  \item{x}{The object to TR_Export.}
  \item{type}{\code{type} gives the format in which the object should be
    converted. The list of recognized formats for this object is obtained with
    \code{type="typelist"}.}
  \item{file}{The path to the file where the converted object should be
    extracted.}
}

\value{
  Return the result from specif method (invisibly if the file
  is written).
}

\author{
  Jos Cludio Faria \email{joseclaudio.faria@gmail.com}
}

\keyword{IO}
\keyword{file}
